Index: /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ClientManager.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ClientManager.cs	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ClientManager.cs	(revision 3011)
@@ -1,3 +1,3 @@
-﻿#region License Information
+#region License Information
 /* HeuristicLab
  * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -30,17 +30,14 @@
 using HeuristicLab.DataAccess.Interfaces;
 using HeuristicLab.Hive.Server.LINQDataAccess;
-using ClientGroup=HeuristicLab.Hive.Contracts.BusinessObjects.ClientGroup;
-using Resource=HeuristicLab.Hive.Contracts.BusinessObjects.Resource;
+using ClientGroup=HeuristicLab.Hive.Contracts.BusinessObjects.ClientGroupDto;
 
 namespace HeuristicLab.Hive.Server.Core {
   class ClientManager: IClientManager {
-
-    ClientDao clientDao = new ClientDao();
-
-    ISessionFactory factory;
+    
+    //ISessionFactory factory;
     List<ClientGroup> clientGroups;
 
     public ClientManager() {
-      factory = ServiceLocator.GetSessionFactory();
+      //factory = ServiceLocator.GetSessionFactory();
       
       clientGroups = new List<ClientGroup>();
@@ -53,23 +50,24 @@
     /// </summary>
     /// <returns></returns>
-    public ResponseList<ClientInfo> GetAllClients() {
-      ISession session = factory.GetSessionForCurrentThread();
-
-      try {
+    public ResponseList<ClientDto> GetAllClients() {
+      /*ISession session = factory.GetSessionForCurrentThread();
+
+      try {
+        
         IClientAdapter clientAdapter =
-          session.GetDataAdapter<ClientInfo, IClientAdapter>();
-
-        ResponseList<ClientInfo> response = new ResponseList<ClientInfo>();
-
-        response.List = new List<ClientInfo>(clientAdapter.GetAll());
+          session.GetDataAdapter<ClientDto, IClientAdapter>();*/
+
+        ResponseList<ClientDto> response = new ResponseList<ClientDto>();
+
+        response.List = new List<ClientDto>(DaoLocator.ClientDao.FindAll());
         response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_GET_ALL_CLIENTS;
         response.Success = true;
 
         return response;
-      }
+      /*}
       finally {
         if (session != null)
           session.EndSession();
-      }
+      }*/
     }
 
@@ -79,5 +77,5 @@
     /// <returns></returns>
     public ResponseList<ClientGroup> GetAllClientGroups() {
-      ISession session = factory.GetSessionForCurrentThread();
+      /*ISession session = factory.GetSessionForCurrentThread();
 
       try {
@@ -85,12 +83,12 @@
           session.GetDataAdapter<ClientGroup, IClientGroupAdapter>();
         IClientAdapter clientAdapter =
-          session.GetDataAdapter<ClientInfo, IClientAdapter>();
+          session.GetDataAdapter<ClientDto, IClientAdapter>();*/
         ResponseList<ClientGroup> response = new ResponseList<ClientGroup>();
 
-        List<ClientGroup> allClientGroups = new List<ClientGroup>(clientGroupAdapter.GetAll());
+        List<ClientGroup> allClientGroups = new List<ClientGroup>(DaoLocator.ClientGroupDao.FindAllWithSubGroupsAndClients());
         ClientGroup emptyClientGroup = new ClientGroup();
-        ICollection<ClientInfo> groupLessClients = clientAdapter.GetGrouplessClients();
+        IEnumerable<ClientDto> groupLessClients = DaoLocator.ClientDao.FindAllClientsWithoutGroup();
         if (groupLessClients != null) {
-          foreach (ClientInfo currClient in groupLessClients) {
+          foreach (ClientDto currClient in groupLessClients) {
             emptyClientGroup.Resources.Add(currClient);
           }
@@ -104,13 +102,13 @@
 
         return response;
-      }
+   /*   }
       finally {
         if (session != null)
           session.EndSession();
-      }
-    }
-
-    public ResponseList<UpTimeStatistics> GetAllUpTimeStatistics() {
-      ResponseList<UpTimeStatistics> response = new ResponseList<UpTimeStatistics>();
+      }*/
+    }
+
+    public ResponseList<UpTimeStatisticsDto> GetAllUpTimeStatistics() {
+      ResponseList<UpTimeStatisticsDto> response = new ResponseList<UpTimeStatisticsDto>();
       response.Success = true;
       return response;
@@ -123,9 +121,9 @@
     /// <returns></returns>
     public ResponseObject<ClientGroup> AddClientGroup(ClientGroup clientGroup) {
-      ISession session = factory.GetSessionForCurrentThread();
-
-      try {
-        IClientGroupAdapter clientGroupAdapter =
-          session.GetDataAdapter<ClientGroup, IClientGroupAdapter>();
+      /*ISession session = factory.GetSessionForCurrentThread();
+
+      try {
+        IClientGroupAdapter clientGroupAdapter =
+          session.GetDataAdapter<ClientGroup, IClientGroupAdapter>();*/
 
         ResponseObject<ClientGroup> response = new ResponseObject<ClientGroup>();
@@ -135,5 +133,6 @@
           response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_ID_MUST_NOT_BE_SET;
         } else {
-          clientGroupAdapter.Update(clientGroup);
+          clientGroup = DaoLocator.ClientGroupDao.Insert(clientGroup);
+          //clientGroupAdapter.Update(clientGroup);
           response.Obj = clientGroup;
           response.Success = true;
@@ -142,9 +141,9 @@
 
         return response;
-      }
+      /*}
       finally {
         if (session != null)
           session.EndSession();
-      }
+      } */
     }
 
@@ -155,14 +154,14 @@
     /// <param name="resource"></param>
     /// <returns></returns>
-    public Response AddResourceToGroup(Guid clientGroupId, Resource resource) {
-      ISession session = factory.GetSessionForCurrentThread();
-
-      try {
-        IClientGroupAdapter clientGroupAdapter =
-          session.GetDataAdapter<ClientGroup, IClientGroupAdapter>();
+    public Response AddResourceToGroup(Guid clientGroupId, ResourceDto resource) {
+      /*ISession session = factory.GetSessionForCurrentThread();
+
+      try {
+        IClientGroupAdapter clientGroupAdapter =
+          session.GetDataAdapter<ClientGroup, IClientGroupAdapter>();*/
 
         Response response = new Response();
 
-        ClientGroup clientGroup = clientGroupAdapter.GetById(clientGroupId);
+        ClientGroup clientGroup = DaoLocator.ClientGroupDao.FindById(clientGroupId);
         if (clientGroup == null) {
           response.Success = false;
@@ -171,5 +170,6 @@
         }
         clientGroup.Resources.Add(resource);
-        clientGroupAdapter.Update(clientGroup);
+        DaoLocator.ClientGroupDao.AddRessourceToClientGroup(resource.Id, clientGroup.Id);          
+        //clientGroupAdapter.Update(clientGroup);
 
         response.Success = true;
@@ -178,9 +178,9 @@
         return response;
       }
-      finally {
-        if (session != null)
-          session.EndSession();
-      }
-    }
+      /*finally {
+        if (session != null)
+          session.EndSession();
+      } 
+    }   */
 
     /// <summary>
@@ -191,13 +191,13 @@
     /// <returns></returns>
     public Response DeleteResourceFromGroup(Guid clientGroupId, Guid resourceId) {
-      ISession session = factory.GetSessionForCurrentThread();
-
-      try {
-        IClientGroupAdapter clientGroupAdapter =
-          session.GetDataAdapter<ClientGroup, IClientGroupAdapter>();
+      /*ISession session = factory.GetSessionForCurrentThread();
+
+      try {
+        IClientGroupAdapter clientGroupAdapter =
+          session.GetDataAdapter<ClientGroup, IClientGroupAdapter>();*/
 
         Response response = new Response();
 
-        ClientGroup clientGroup = clientGroupAdapter.GetById(clientGroupId);
+        ClientGroup clientGroup = DaoLocator.ClientGroupDao.FindById(clientGroupId);
         if (clientGroup == null) {
           response.Success = false;
@@ -205,8 +205,9 @@
           return response;
         }
-        foreach (Resource resource in clientGroup.Resources) {
+        foreach (ResourceDto resource in clientGroup.Resources) {
           if (resource.Id == resourceId) {
             clientGroup.Resources.Remove(resource);
-            clientGroupAdapter.Update(clientGroup);
+            DaoLocator.ClientGroupDao.RemoveRessourceFromClientGroup(resource.Id, clientGroup.Id);
+            //clientGroupAdapter.Update(clientGroup);
             response.Success = true;
             response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_RESOURCE_REMOVED;
@@ -219,12 +220,12 @@
         return response;
       }
-      finally {
-        if (session != null)
-          session.EndSession();
-      }
-    }
+      /*finally {
+        if (session != null)
+          session.EndSession();
+      }
+    }   */
 
     public ResponseObject<List<ClientGroup>> GetAllGroupsOfResource(Guid resourceId) {
-      ISession session = factory.GetSessionForCurrentThread();
+      /*ISession session = factory.GetSessionForCurrentThread();
 
       try {
@@ -232,11 +233,11 @@
           session.GetDataAdapter<ClientGroup, IClientGroupAdapter>();
         IClientAdapter clientAdapter =
-          session.GetDataAdapter<ClientInfo, IClientAdapter>();
+          session.GetDataAdapter<ClientDto, IClientAdapter>();*/
 
         ResponseObject<List<ClientGroup>> response = new ResponseObject<List<ClientGroup>>();
 
-        ClientInfo client = clientAdapter.GetById(resourceId);
+        ClientDto client = DaoLocator.ClientDao.FindById(resourceId);
         if (client != null) {
-          List<ClientGroup> groupsOfClient = new List<ClientGroup>(clientGroupAdapter.MemberOf(client));
+          List<ClientGroup> groupsOfClient = new List<ClientGroup>(DaoLocator.ClientGroupDao.MemberOf(client));
           response.Obj = groupsOfClient;
           response.Success = true;
@@ -250,20 +251,20 @@
         return response;
       }
-      finally {
-        if (session != null)
-          session.EndSession();
-      }
-    }
+      /*finally {
+        if (session != null)
+          session.EndSession();
+      }
+    }   */
 
     public Response DeleteClientGroup(Guid clientGroupId) {
-      ISession session = factory.GetSessionForCurrentThread();
-
-      try {
-        IClientGroupAdapter clientGroupAdapter =
-          session.GetDataAdapter<ClientGroup, IClientGroupAdapter>();
+      /*ISession session = factory.GetSessionForCurrentThread();
+
+      try {
+        IClientGroupAdapter clientGroupAdapter =
+          session.GetDataAdapter<ClientGroup, IClientGroupAdapter>();*/
 
         Response response = new Response();
 
-        ClientGroup clientGroup = clientGroupAdapter.GetById(clientGroupId);
+        ClientGroup clientGroup = DaoLocator.ClientGroupDao.FindById(clientGroupId);
         if (clientGroup == null) {
           response.Success = false;
@@ -272,5 +273,5 @@
         }
 
-        clientGroupAdapter.Delete(clientGroup);
+        DaoLocator.ClientGroupDao.Delete(clientGroup);
 
         response.Success = true;
@@ -278,9 +279,9 @@
         return response;
 
-      } finally {
-        if (session != null)
-          session.EndSession();
-      }
-    }
+      }/* finally {
+        if (session != null)
+          session.EndSession();
+      }
+    }    */
 
     #endregion
Index: /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/DaoLocator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/DaoLocator.cs	(revision 3011)
+++ /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/DaoLocator.cs	(revision 3011)
@@ -0,0 +1,64 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Hive.Server.DataAccess;
+using HeuristicLab.Hive.Server.LINQDataAccess;
+
+namespace HeuristicLab.Hive.Server.Core {
+  public class DaoLocator {
+    
+    [ThreadStatic] private static IClientDao clientDao;
+    [ThreadStatic] private static IClientConfigDao clientConfigDao;
+    [ThreadStatic] private static IClientGroupDao clientGroupDao;
+    [ThreadStatic] private static IJobDao jobDao;
+    [ThreadStatic] private static IPluginInfoDao pluginInfoDao;
+
+    public static IClientDao ClientDao {
+      get {
+        if (clientDao == null)
+          clientDao = new ClientDao();
+        return clientDao;
+      }
+    }
+
+    public static IClientConfigDao ClientConfigDao {
+      get {
+        if(clientConfigDao == null)
+          clientConfigDao = new ClientConfigDao();
+        return clientConfigDao;
+      }
+    }
+
+    public static IClientGroupDao ClientGroupDao {
+      get {
+        if(clientGroupDao == null)
+          clientGroupDao = new ClientGroupDao();
+        return clientGroupDao;
+      }
+    }
+
+    public static IJobDao JobDao {
+      get {
+        if(jobDao == null)
+          jobDao = new JobDao();
+        return jobDao;
+      }
+    }
+
+    public static IPluginInfoDao PluginInfoDao {
+      get {
+        if(pluginInfoDao == null)
+          pluginInfoDao = new PluginInfoDao();
+        return pluginInfoDao;
+      }
+    }
+
+    public static void DestroyContext() {
+      if (ContextFactory.Context != null) {
+        ContextFactory.Context.Dispose();
+        ContextFactory.Context = null;
+      }
+    }
+
+  }
+}
Index: /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/DbTestApp.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/DbTestApp.cs	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/DbTestApp.cs	(revision 3011)
@@ -299,5 +299,5 @@
 
       IJobAdapter jobAdapter =
-        session.GetDataAdapter<HeuristicLab.Hive.Contracts.BusinessObjects.Job, IJobAdapter>();
+        session.GetDataAdapter<HeuristicLab.Hive.Contracts.BusinessObjects.JobDto, IJobAdapter>();
 
       Stream s = jobAdapter.GetSerializedJobStream(
@@ -349,5 +349,5 @@
     }
 
-    private void TestJobResultDeserialization() {
+    /*private void TestJobResultDeserialization() {
       ExecutionEngineFacade executionEngineFacade =
         new ExecutionEngineFacade();
@@ -359,21 +359,122 @@
       IStorable restoredJob =
         PersistenceManager.RestoreFromGZip(response.Obj.SerializedJobResultData);
-    }
+    } */
+
+    ClientDao clientDao = new ClientDao();
+    ClientGroupDao cgd = new ClientGroupDao();
 
     private void TestLINQImplementation() {      
-      ClientDao clientDao = new ClientDao();      
-      ClientInfo info = new ClientInfo();
-      info.Id = Guid.NewGuid();
-      info.FreeMemory = 1000;
-      info.Login = DateTime.Now;
-      info.Memory = 1000;
-      info.Name = "jackie";
-      info.NrOfCores = 3;
-      info.NrOfFreeCores = 2;
-      info.CpuSpeedPerCore = 2500;
-      info.State = State.idle;
-      info = clientDao.Insert(info);
-
-    }
+      
+      
+      ClientDto c1 = new ClientDto();
+      c1.Id = Guid.NewGuid();
+      c1.FreeMemory = 1000;
+      c1.Login = DateTime.Now;
+      c1.Memory = 1000;
+      c1.Name = "jackie";
+      c1.NrOfCores = 3;
+      c1.NrOfFreeCores = 2;
+      c1.CpuSpeedPerCore = 2500;
+      c1.State = State.idle;
+      c1 = clientDao.Insert(c1);
+
+      clientDao.Update(c1);
+
+      ClientDto c2 = new ClientDto();
+      c2.Id = Guid.NewGuid();
+      c2.FreeMemory = 600;
+      c2.Login = DateTime.Now;
+      c2.Memory = 2048;
+      c2.Name = "HPCs";
+      c2.NrOfCores = 4;
+      c2.NrOfFreeCores = 1;
+      c2.CpuSpeedPerCore = 4000;
+      c2.State = State.idle;
+      c2 = clientDao.Insert(c2);
+
+      //ClientDto info2 = clientDao.FindById(info.Id);
+      //Console.WriteLine(info2);
+      
+      ClientGroupDto tg = new ClientGroupDto();
+      tg.Name = "TopGroup";
+      tg = cgd.Insert(tg);
+
+      ClientGroupDto sg = new ClientGroupDto();
+      sg.Name = "Subgroup";
+      sg = cgd.Insert(sg);
+
+      cgd.AddRessourceToClientGroup(sg.Id, tg.Id);
+      cgd.AddRessourceToClientGroup(c1.Id, tg.Id);
+      cgd.AddRessourceToClientGroup(c2.Id, tg.Id);
+
+      JobDto job = new JobDto {
+                                Client = c1,
+                                CoresNeeded = 2,
+                                DateCreated = DateTime.Now,
+                                MemoryNeeded = 500,
+                                Percentage = 0,
+                                Priority = 1,
+                                State = State.offline
+                              };
+
+      job = DaoLocator.JobDao.Insert(job);
+
+
+      DaoLocator.JobDao.AssignClientToJob(c1.Id, job.Id);
+
+      List<ClientGroupDto> list = new List<ClientGroupDto>(cgd.FindAllWithSubGroupsAndClients());
+      
+      cgd.RemoveRessourceFromClientGroup(sg.Id, tg.Id);
+
+      cgd.Delete(sg);
+      cgd.Delete(tg);
+      clientDao.Delete(c1);
+      clientDao.Delete(c2);
+
+    }
+
+    private void StressTest() {
+      //Speed Test
+      Random r = new Random();
+
+
+      for (int i = 0; i < 200; i++) {
+        ClientGroupDto mg = new ClientGroupDto();
+        mg.Name = "MainGroup" + i;
+        mg = cgd.Insert(mg);
+
+        populateMainGroup(mg, 3);
+      }
+    }
+
+    private void populateMainGroup(ClientGroupDto mg, int p) {
+      Random r = new Random();
+
+      for (int j = 0; j < r.Next(15); j++) {
+        ClientDto client = new ClientDto();
+        client.Id = Guid.NewGuid();
+        client.FreeMemory = r.Next(1000);
+        client.Login = DateTime.Now;
+        client.Memory = r.Next(500);
+        client.Name = "client" + mg.Name + "_" + j;
+        client.NrOfCores = 3;
+        client.NrOfFreeCores = 2;
+        client.CpuSpeedPerCore = 2500;
+        client.State = State.idle;
+        client = clientDao.Insert(client);
+        cgd.AddRessourceToClientGroup(client.Id, mg.Id);
+      }
+      for (int i = 0; i < r.Next(p); i++) {
+        ClientGroupDto sg = new ClientGroupDto();
+        sg.Name = "SubGroup " + mg.Name + " - " + p;
+        sg = cgd.Insert(sg);
+        cgd.AddRessourceToClientGroup(sg.Id, mg.Id);
+        populateMainGroup(sg, p-1);
+      }
+
+      
+    }
+
+
 
     public override void Run() {
@@ -384,6 +485,23 @@
       //TestJobResultDeserialization();
 
-      TestLINQImplementation();
-
+      //TestLINQImplementation();
+      //StressTest();
+
+      //SpeedTest();
+      TestJobBytearrFetching();
+
+    }
+
+    private void TestJobBytearrFetching() {
+      byte[] arr = DaoLocator.JobDao.GetBinaryJobFile(new Guid("A3386907-2B3C-4976-BE07-04D660D40A5B"));
+      Console.WriteLine(arr);
+    }
+
+    private void SpeedTest() {
+      DateTime start = new DateTime();
+      List<ClientGroupDto> list = new List<ClientGroupDto>(cgd.FindAllWithSubGroupsAndClients());
+      DateTime end = new DateTime();
+      TimeSpan used = end - start;
+      Console.WriteLine(used.TotalMilliseconds);
     }
 
Index: /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/DefaultScheduler.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/DefaultScheduler.cs	(revision 3011)
+++ /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/DefaultScheduler.cs	(revision 3011)
@@ -0,0 +1,87 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Hive.Server.Core.InternalInterfaces;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using HeuristicLab.Hive.Server.DataAccess;
+using System.Threading;
+using HeuristicLab.DataAccess.Interfaces;
+
+namespace HeuristicLab.Hive.Server.Core {
+  class DefaultScheduler: IScheduler {
+
+    //private ISessionFactory factory;
+
+    private static Mutex jobLock =
+      new Mutex();
+
+    #region IScheduler Members
+
+    public DefaultScheduler() {
+      //factory = ServiceLocator.GetSessionFactory();
+    }
+
+    public bool ExistsJobForClient(HeuristicLab.Hive.Contracts.BusinessObjects.HeartBeatData hbData) {
+      //ISession session = factory.GetSessionForCurrentThread();
+
+      //try {
+        /*IJobAdapter jobAdapter =
+          session.GetDataAdapter<JobDto, IJobAdapter>();*/
+
+        List<JobDto> allOfflineJobsForClient = new List<JobDto>(DaoLocator.JobDao.FindFittingJobsForClient(State.offline, hbData.FreeCores, hbData.FreeMemory));
+          /*jobAdapter.FindJobs(State.offline, 
+          hbData.FreeCores,
+          hbData.FreeMemory, 
+          hbData.ClientId));*/
+        return (allOfflineJobsForClient != null && allOfflineJobsForClient.Count > 0);
+      //}
+      /*finally {
+        if (session != null)
+          session.EndSession();
+      } */
+    }   
+
+    public HeuristicLab.Hive.Contracts.BusinessObjects.JobDto GetNextJobForClient(Guid clientId) {
+      /*ISession session = factory.GetSessionForCurrentThread();
+
+      try {
+        IJobAdapter jobAdapter =
+          session.GetDataAdapter<JobDto, IJobAdapter>();
+
+        IClientAdapter clientAdapter =
+          session.GetDataAdapter<ClientDto, IClientAdapter>();*/
+
+        /// Critical section ///
+        jobLock.WaitOne();
+
+        ClientDto client = DaoLocator.ClientDao.FindById(clientId);
+      LinkedList<JobDto> allOfflineJobsForClient =
+        new LinkedList<JobDto>(DaoLocator.JobDao.FindFittingJobsForClient(State.offline, client.NrOfFreeCores,
+                                                                          client.FreeMemory));
+
+        JobDto jobToCalculate = null;
+        if (allOfflineJobsForClient != null && allOfflineJobsForClient.Count > 0) {
+          jobToCalculate = allOfflineJobsForClient.First.Value;
+          jobToCalculate.State = State.calculating;
+          jobToCalculate.Client = client;
+          jobToCalculate.Client.State = State.calculating;          
+          jobToCalculate.DateCalculated = DateTime.Now;
+          DaoLocator.JobDao.AssignClientToJob(client.Id, jobToCalculate.Id);
+          DaoLocator.JobDao.Update(jobToCalculate);
+          DaoLocator.ClientDao.Update(jobToCalculate.Client);
+        }
+        jobLock.ReleaseMutex();
+        /// End Critical section ///
+
+        return jobToCalculate;
+      }
+      /*finally {
+        if (session != null)
+          session.EndSession();
+      } 
+    }   */
+
+    #endregion
+  }
+}
Index: /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ExecutionEngineFacade.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ExecutionEngineFacade.cs	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ExecutionEngineFacade.cs	(revision 3011)
@@ -40,5 +40,5 @@
     #region IExecutionEngineFacade Members
 
-    public ResponseObject<Job> AddJob(SerializedJob job) {
+    public ResponseObject<JobDto> AddJob(SerializedJob job) {
       return jobManager.AddNewJob(job);
     }
@@ -48,5 +48,5 @@
     }
 
-    public ResponseObject<SerializedJobResult> 
+    public ResponseObject<SerializedJob> 
       GetLastSerializedResult(Guid jobId, bool requested) {
       return jobManager.GetLastSerializedJobResultOf(jobId, requested);
Index: /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/HeuristicLab.Hive.Server.Core-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/HeuristicLab.Hive.Server.Core-3.2.csproj	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/HeuristicLab.Hive.Server.Core-3.2.csproj	(revision 3011)
@@ -77,4 +77,5 @@
       <RequiredTargetFramework>3.0</RequiredTargetFramework>
     </Reference>
+    <Reference Include="System.Transactions" />
     <Reference Include="System.Windows.Forms" />
     <Reference Include="System.Xml.Linq">
@@ -97,5 +98,7 @@
     <Compile Include="ClientFacade.cs" />
     <Compile Include="ClientManager.cs" />
+    <Compile Include="DaoLocator.cs" />
     <Compile Include="DbTestApp.cs" />
+    <Compile Include="DefaultScheduler.cs" />
     <Compile Include="ExecutionEngineFacade.cs" />
     <Compile Include="Authorization\HivePermissionManager.cs" />
Index: /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/HiveServerCorePlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/HiveServerCorePlugin.cs	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/HiveServerCorePlugin.cs	(revision 3011)
@@ -29,5 +29,10 @@
   [PluginFile("HeuristicLab.Hive.Server.Core-3.2.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.DataAccess-3.2")]
   [PluginDependency("HeuristicLab.Hive.Contracts-3.2")]
+  [PluginDependency("HeuristicLab.Hive.JobBase-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Server.DataAccess-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Server.LINQDataAccess-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Server.Security.Contracts-3.2")]
   public class HiveServerCorePlugin : PluginBase {
   }
Index: /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/InternalInterfaces/IInternalJobManager.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/InternalInterfaces/IInternalJobManager.cs	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/InternalInterfaces/IInternalJobManager.cs	(revision 3011)
@@ -29,5 +29,5 @@
 namespace HeuristicLab.Hive.Server.Core.InternalInterfaces {
   interface IInternalJobManager {
-    void ResetJobsDependingOnResults(Job job);
+    void ResetJobsDependingOnResults(JobDto job);
 
     Stream GetJobStreamById(Guid jobId);
Index: /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/InternalInterfaces/IScheduler.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/InternalInterfaces/IScheduler.cs	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/InternalInterfaces/IScheduler.cs	(revision 3011)
@@ -29,5 +29,5 @@
   public interface IScheduler {
     bool ExistsJobForClient(HeartBeatData hbData);
-    Job GetNextJobForClient(Guid clientId);
+    JobDto GetNextJobForClient(Guid clientId);
   }
 }
